/* ksnet.cc
----------------------------------------------------------------
   饹 Ksnet μ¸
----------------------------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"                                 /* ̴Ķ */
#include "list.h"                               /* 饹 List  */
#include "element.h"                         /* 饹 Element  */
#include "p_tmp.h"         /* ƥץ졼ȥ饹 Receive, Send  */
#include "ksnet.h"                             /* 饹 Ksnet  */


Ksnet::Ksnet(char* o_name, int o_num, char* p_str,
	int numinput, int numlateral, int numsegment) : Element()
{
	class_name = "Ksnet";
	Init(o_name, o_num, p_str, numinput, numlateral, numsegment);
}

Boolean Ksnet::Init(char* o_name, int o_num, char* p_str,
	int numinput, int numlateral, int numsegment)
{
	/* ninput */
	if (numinput <= 0) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// 'ninput' must be natural number.
		Oprint();
		exit(1);
	}
	ninput = numinput;

	/* nlateral */
	if (numlateral < 0) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// 'nlateral' must not be negative number.
		Oprint();
		exit(1);
	}
	nlateral = numlateral;

	/* nsegment */
	if (numsegment <= 0) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// 'nsegment' must be natural number.
		Oprint();
		exit(1);
	}
	nsegment = numsegment;

	/* üҡüҤν */
	if ((rpl = new Receive<double>[nlateral]) == NULL) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// Cannot allocate memory for rpl.
		Oprint();
		exit(1);
	}
	int i;
	for (i = 0; i < nlateral; i++) {
		rpl[i].Init("rpl", i);
	}

	if ((rpu = new Receive<double>[ninput]) == NULL) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// Cannot allocate memory for rpu.
		Oprint();
		exit(1);
	}
	for (i = 0; i < ninput; i++) {
		rpu[i].Init("rpu", i);
	}

	sp.Init("sp", 0);

	/* ե̾ */
	char fn_sub[50];
	Set_data_string(p_str);
    if (sscanf(data_string, "%s", fn_sub) != 1) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Init
			// Cannot scan filename for Sub_connect.
		Oprint();
		exit(1);
	}
	Clear_data_string();

	/* ƻ³ */
	Sub_connect(fn_sub);

	return Element::Init(o_name, o_num);
}

Ksnet::Ksnet(void) : Element()
{
	class_name = "Ksnet";
}

Ksnet::~Ksnet(void)
{
	delete [] L;
	delete [] B;
	delete [] K;
	delete [] P;
	
	for (int i = 0; i < nsegment; i++) {
		delete [] myu[i];
	}
	delete [] myu;
	delete [] sigma;
	
	delete [] input_next_time;
	delete [] input_current_time;
	delete [] Q_down;
	
	delete [] rpu;
	delete [] rpl;
}

void Ksnet::Register_receive_ports(void)
{
	int i;
	for (i = 0; i < nlateral; i++) {
		Register((void*) &rpl[i]);
	}
	for (i = 0; i < ninput; i++) {
		Register((void*) &rpu[i]);
	}
}

void Ksnet::Register_send_ports(void)
{
	Register((void*) &sp);
}

void Ksnet::Set_parameter(FILE* fp)
{
	L = new double[nsegment];
	B = new double[nsegment];
	K = new double[nsegment];
	P = new double[nsegment];

	int i;
	for (i = 0; i < nsegment; i++) {
	    L[i] = -99999.; B[i] = -99999.;
		K[i] = -99999.; P[i] = -99999.;
	}

	double l_tmp, b_tmp, g_tmp, m_tmp, p_tmp;
	for (i = 0; i < nsegment; i++) {
		if (fscanf(fp, "%lf %lf %lf %lf %lf",
			   &l_tmp, &b_tmp, &g_tmp, &m_tmp, &p_tmp) != 5) {
			Eprint(__FILE__, __LINE__);
		    	// Kw_for_slope::Set_parameter
				// Cannot scan information of parameter.
			Oprint();
			exit(1);
		}

// 		if ((l_tmp <= 0.) || (b_tmp <= 0.)
// 			|| (g_tmp <= 0.) || (m_tmp <= 0.) || (p_tmp <= 0.)) {
// 			Eprint(__FILE__, __LINE__);
// 		    	// Kw_for_slope::Set_parameter
// 				// Invalid parameter are given.
// 			Oprint();
// 			exit(1);
// 		}

		// modified by Yutaka ICHIKAWA
		// Wed Sep 15 14:29:20 1999
		if ((l_tmp < 0.) || (b_tmp < 0.)
			|| (g_tmp < 0.) || (m_tmp <= 0.) || (p_tmp <= 0.)) {
			Eprint(__FILE__, __LINE__);
		    	// Kw_for_slope::Set_parameter
				// Invalid parameter are given.
			Oprint();
			exit(1);
		}

		// added by Yutaka ICHIKAWA
		// Wed Sep 15 14:36:34 1999
		// Ūʲƻʬ(Ĺ0βƻʬ)ؤб

		if (l_tmp == 0.0)
		{
			b_tmp = 100.0;		// ŪͤͿ
			g_tmp = 100.0;		// ŪͤͿ
		}

		if (p_tmp > 1.) {
			Eprint(__FILE__, __LINE__);
		    	// Kw_for_slope::Set_parameter
				// 'P' must be smaller than 1.
			Oprint();
			exit(1);
		}

		L[i] = l_tmp;
		B[i] = b_tmp;
		K[i] = pow(b_tmp, 1. - p_tmp)
			* pow((sqrt(g_tmp) / m_tmp), - p_tmp);
		P[i] = p_tmp;

// 		printf("[%d] L : %lf, B : %lf, K : %lf, P : %lf\n",
// 			i, L[i], B[i], K[i], P[i]);

	}

	sum_length = 0.; area = 0.;
	for (i = 0; i < nsegment; i++) {
		sum_length += L[i];
		area += L[i] * B[i];
	}

	/* γ */
	input_next_time = new double[ninput];
	input_current_time = new double[ninput];
	Q_down = new double[ninput + nsegment];
}

// void Ksnet::Set_initial_state(FILE* fp)
// {
// 	/* ׻ϻ */
// 	char s[256];
// 	if (fgets(s, 256, fp) == NULL) {
// 		Eprint(__FILE__, __LINE__);
// 	    	// Kw_for_slope::Set_initial_state
// 			// Cannot read 'current_time'.
// 		Oprint();
// 		exit(1);
// 	}
// 	if (sscanf(s, "%ld", &current_time) != 1) {
// 		Eprint(__FILE__, __LINE__);
// 	    	// Kw_for_slope::Set_initial_state
// 			// Cannot get 'current_time'.
// 		Oprint();
// 		exit(1);
// 	}
// 
// 	int i;
// 	char** buf = new char*[3];
// 	for (i = 0; i < 3; i++) {
// 		buf[i] = new char[256];
// 		if (fgets(buf[i], 256, fp) == NULL) {
// 			Eprint(__FILE__, __LINE__);
// 	    		// Kw_for_slope::Set_initial_state
// 				// Cannot get data.
// 			Oprint();
// 			exit(1);
// 		}
// 	}
// 
// 	/* ή */
// 	double Q_tmp;
// 	sum_input_next = 0.;
//     for (i = 0; i < ninput; i++) {
// 		// ڡ򥹥å
// 	    while ((*buf[0] == ' ') || (*buf[0] == '\t')) buf[0]++;
// 		if (sscanf(buf[0], "%lf", &Q_tmp) != 1) {
// 			Eprint(__FILE__, __LINE__);
//     			// Kw_for_slope::Set_initial_state
// 				// Cannot get 'inflow'.
// 			Oprint();
// 			exit(1);
// 		}
// 		// 餽ʬʤƤ
// 		while ((*buf[0] != ' ') && (*buf[0] != '\t')) buf[0]++;
// 
// 		if (Q_tmp < 0.) {
// 			Eprint(__FILE__, __LINE__);
//     			// Kw_for_slope::Set_initial_state
// 				// 'inflow' should NOT be a negative value.
// 			Oprint();
// 			exit(1);
// 		}
// 		input_next_time[i] = Q_tmp;
// 		sum_input_next += Q_tmp;
// 	}
// 
// 	/* ¦ή */
// 	lateral_next_time = 0.;
//     for (i = 0; i < nlateral; i++) {
// 		// ڡ򥹥å
// 	    while ((*buf[1] == ' ') || (*buf[1] == '\t')) buf[1]++;
// 		if (sscanf(buf[1], "%lf", &Q_tmp) != 1) {
// 			Eprint(__FILE__, __LINE__);
//     			// Kw_for_slope::Set_initial_state
// 				// Cannot get 'lateral inflow'.
// 			Oprint();
// 			exit(1);
// 		}
// 		// 餽ʬʤƤ
// 		while ((*buf[0] != ' ') && (*buf[0] != '\t')) buf[0]++;
// 
// 		if (Q_tmp < 0.) {
// 			Eprint(__FILE__, __LINE__);
//     			// Kw_for_slope::Set_initial_state
// 				// 'lateral inflow' should NOT be a negative value.
// 			Oprint();
// 			exit(1);
// 		}
// 		lateral_next_time += Q_tmp;
// 	}
// 
// 	/* ή */
// 	if (sscanf(buf[2], "%lf", &output_current_time) != 1) {
// 		Eprint(__FILE__, __LINE__);
//     		// Kw_for_slope::Set_initial_state
// 			// Cannot get 'outflow'.
// 		Oprint();
// 		exit(1);
// 	}
// 
// 	for (i = 0; i < 3; i++) {
// 		buf[i] = NULL;
// 		delete [] buf[i];
// 	}
// 	delete [] buf;
// 
// 	if (output_current_time < 0.) {
// 		Eprint(__FILE__, __LINE__);
//     		// Kw_for_slope::Set_initial_state
// 			// 'outflow' should NOT be a negative value.
// 		Oprint();
// 		exit(1);
// 	}
// }

void Ksnet::Set_initial_state(FILE* fp)
{
	// ׻ϻɤ߹ࡣ
	// ׻ϻή̤ͤϡInitial_output Ǽꤹ롣

	char s[256];
	if (fgets(s, 256, fp) == NULL) {
		Eprint(__FILE__, __LINE__);
	    	// Ksnet::Set_initial_state
			// Cannot read 'current_time'.
		Oprint();
		exit(1);
	}
	if (sscanf(s, "%ld", &current_time) != 1) {
		Eprint(__FILE__, __LINE__);
	    	// Ksnet::Set_initial_state
			// Cannot get 'current_time'.
		Oprint();
		exit(1);
	}
}

// void Ksnet::Save_terminal_state(FILE* fp)
// {
// 	if (fp == NULL) {
// 		Eprint(__FILE__, __LINE__);
// 		    // Ksnet::Save_terminal_state
// 			// Cannot save terminal state.
// 		Oprint();
// 		exit(1);
// 	}
// 
// 	/* current_time */
// 	fprintf(fp, "%ld\n", current_time);
// 
// 	/* ǾήüǤή */
// 	int i;
// 	for (i = 0; i < ninput; i++)
// 		fprintf(fp, "%f ", input_current_time[i]);
// 	fprintf(fp, "\n");
// 
// 	/* ¦ή */
// 	double tmp;
// 	for (i = 0; i < nlateral; i++) {
// 		tmp = rpl[i].Get_data(current_time);
// 		fprintf(fp, "%f ", tmp);
// 	}
// 	fprintf(fp, "\n");
// 
// 	/* ǲήüǤή */
// 	fprintf(fp, "%f\n", output_current_time);
// }

void Ksnet::Save_terminal_state(FILE* fp)
{
	if (fp == NULL) {
		Eprint(__FILE__, __LINE__);
		    // Ksnet::Save_terminal_state
			// Cannot save terminal state.
		Oprint();
		exit(1);
	}

	/* current_time */
	fprintf(fp, "%ld\n", current_time);
}

void Ksnet::Sub_connect(char* cf_name)
{
	FILE* fp_c;
	if ((fp_c = fopen(cf_name, "r")) == NULL) {
		Eprint_fopen(__FILE__, __LINE__, cf_name, "r");
		Oprint();
		exit(1);
	}

	sigma = new int[nsegment];
	myu = new int*[nsegment];
	
	char* buf = new char[256];
	int line = 0; int segment = -1; int j;
	int sigma_tmp, myu_tmp;
	while (fgets(buf, 256, fp_c) != NULL) {
		line++;
		if ((buf[0] == '#') || (buf[0] == '\n')) continue;
		segment++;
		if (segment == nsegment) {
			Eprint(__FILE__, __LINE__);
				// Ksnet::Sub_connect
				// Too many information for sub-connect.
			Oprint();
			exit(1);
		}

		if (sscanf(buf, "%d", &sigma_tmp) != 1) {
			Eprint(__FILE__, __LINE__);
				// Ksnet::Sub_connect
				// Cannot scan 'sigma'.
			fprintf(stderr, "\tLine %d.\n", line);
			Oprint();
			exit(1);
		}
		if (sigma_tmp <= 0) {
			Eprint(__FILE__, __LINE__);
				// Ksnet::Sub_connect
				// 'sigma' must be natural number.
			fprintf(stderr, "\tLine %d.\n", line);
			Oprint();
			exit(1);
		}
		sigma[segment] = sigma_tmp;

		while (*buf != ':') buf++;
		buf++;

		myu[segment] = new int[sigma[segment]];
		for (j = 0; j < sigma[segment]; j++) {
		    while ((*buf == ' ') || (*buf == '\t')) buf++;
			if (sscanf(buf, "%d", &myu_tmp) != 1) {
				Eprint(__FILE__, __LINE__);
					// Ksnet::Sub_connect
					// Cannot scan 'myu'.
				Oprint();
				exit(1);
			}
			myu[segment][j] = myu_tmp;
			while ((*buf != ' ') && (*buf != '\t') && (*buf != '\n'))
				buf++;
		}
	}
	fclose(fp_c);

	if (segment != nsegment - 1) {
		Eprint(__FILE__, __LINE__);
			// Ksnet::Sub_connect
			// Too few information for sub-connect.
		Oprint();
		exit(1);
	}
}

double Ksnet::Storage_by_continuity(double q0_tmp)
{
	double storage;
	storage = storage_current_time + 
		(sum_input_current + lateral_current_time
		+ lateral_next_time - output_current_time - sum_length * q0_tmp)
		* time_step / 2.;
	return storage;
}

void Ksnet::Get_input_info(void)
{
	for (int j = 0; j < ninput; j++) {
		Q_down[j] = input_next_time[j];
	}
}

double Ksnet::Storage_by_integral(double q0_tmp)
{
	double storage = 0.;
	double s_tmp;
	double sum_local_input;
	
	int j, k;
	for (j = 0; j < nsegment; j++) {
		sum_local_input = 0.;
		for (k = 0; k < sigma[j]; k++) {
			sum_local_input += Q_down[myu[j][k] - 1];
		}
		Q_down[j + ninput] = sum_local_input + q0_tmp * L[j];
		if (q0_tmp == 0.) {
			s_tmp = K[j] * L[j]	* pow(sum_local_input, P[j]);
		}
		else {
			s_tmp = K[j] / q0_tmp / (P[j] + 1.)
				* (pow((fabs(Q_down[j + ninput])), (P[j] + 1.))
				- pow((fabs(sum_local_input)), (P[j] + 1.)));
		}
		storage += s_tmp;
	}
	return storage;
}

time_t Ksnet::Calculate_time_step(void)
{
// 	int i, j;
// 	double dt;
// 	double min_of_time_forward = 1000000.;         /* 10ְʾ^^; */
// 	double min_of_time_backward = 1000000.;        /* 10ְʾ^^; */
// 	double data_span;
// 	double time_span;
// 	double data_current = 0.;
// 
// 	void *dp_f, *dp_l;
// 
// 	/* rpl */
// 	for (i = 0; i < nlateral; i++) {
// 	    ((Port*) &rpl[i])->Get_data_pack(dp_f, current_time);
// 		((Port*) &rpl[i])->Get_data_pack(current_time, dp_l);
// 
// 		if ((dt = (double)(((Data_pack*)dp_l)->Data_time()
// 			- current_time)) == 0.) {
// 		    dp_f = dp_l;
// 			if (((Port*) &rpl[i])->
// 				Get_data_pack(current_time + 1, dp_l) == YES) {
// 			    dt = (double)(((Data_pack*)dp_l)->Data_time()
// 							  - current_time);
// 			}
// 			else {
// // 			    return 1; // ⤦ʾʤʤΤ
// // 				          //  return 
// 				return 0; // ʾʤʤadder.h, cc 򻲾
// 			}
// 		}
// 		min_of_time_forward
// 			= ((dt < min_of_time_forward) ? dt : min_of_time_forward);
// 
// 		dt = (double)(current_time - ((Data_pack*)dp_f)->Data_time());
// 		min_of_time_backward
// 			= ((dt < min_of_time_backward) ? dt : min_of_time_backward);
// 
// 		data_current += rpl[i].Get_data(current_time);
// 	}
// //  ¦ήñ̤ m^3/s ΤȤ
// 	data_current /= area;
// 
// //  ¦ήñ̤ m^2/s ΤȤ
// //	data_current /= sum_length;
// 
// 	/* rpu */
// 	for (i = 0; i < ninput; i++) {
// 	    ((Port*) &rpu[i])->Get_data_pack(dp_f, current_time);
// 		((Port*) &rpu[i])->Get_data_pack(current_time, dp_l);
// 
// 		if ((dt = (double)(((Data_pack*)dp_l)->Data_time()
// 			- current_time)) == 0.) {
// 		    dp_f = dp_l;
// 			if (((Port*) &rpu[i])->
// 				Get_data_pack(current_time + 1, dp_l) == YES) {
// 			    dt = (double)(((Data_pack*)dp_l)->Data_time()
// 							  - current_time);
// 			}
// 			else {
// // 			    return 1; // ⤦ʾʤʤΤ
// // 				          //  return 
// 				return 0; // ʾʤʤadder.h, cc 򻲾
// 			}
// 		}
// 		min_of_time_forward
// 			= ((dt < min_of_time_forward) ? dt : min_of_time_forward);
// 
// 		dt = (double)(current_time - ((Data_pack*)dp_f)->Data_time());
// 		min_of_time_backward
// 			= ((dt < min_of_time_backward) ? dt : min_of_time_backward);
// 	}
// 	    
// 	double data_forward = 0.;
// 	double data_backward = 0.;
// 	for (i = 0; i < nlateral; i++) {
// 		data_forward +=	rpl[i].
// 			Get_data(current_time + (time_t)min_of_time_forward);
// 		data_backward += rpl[i].
// 			Get_data(current_time - (time_t)min_of_time_backward);
// 	}
// //  ¦ήñ̤ m^3/s ΤȤ
// 	data_span = (data_forward - data_backward) / area;
// 
// //  ¦ήñ̤ m^2/s ΤȤ
// //	data_span = (data_forward - data_backward) / sum_length;
// 
// 	time_span = min_of_time_forward + min_of_time_backward;
// 
// 	dt = min_of_time_forward;
// 	min_of_time_forward = 1000000.;
// 
// 	double sum_local_input;
// 	double h, a, m, arg_pow;
// 	for (i = 0; i < nsegment; i++) {
// 		sum_local_input = 0.;
// 		for (j = 0; j < sigma[i]; j++) {
// 			sum_local_input += Q_down[myu[i][j] - 1];
// 		}
// 		Q_down[i + ninput] = sum_local_input + q0 * L[i];
// 
// 		if (q0 >= 0.) {
// 			h = K[i] * pow((fabs(Q_down[i + ninput])), P[i]) / B[i];
// 		}
// 		else {
// 			h = K[i] * pow((fabs(sum_local_input)), P[i]) / B[i];
// 		}
// 
// 		/* L[i]  0. ΤȤϥåʤ */
// 		if (L[i] != 0.) {
// 			m = 1. / P[i];
// 			a = pow(B[i], m - 1) / pow(K[i],m);
// 			/* ξ */
// 			arg_pow = h + data_current * dt
// 				+ dt * dt * data_span / time_span / 2.;
// 			while ((L[i] / dt) < a * m * pow((fabs(arg_pow)), m - 1.)) {
// 				dt /= 2.;
// 				arg_pow = h + data_current * dt
// 					+ dt * dt * data_span / time_span / 2.;
// 			}
// 			if (dt == 0.) {
// 				Eprint(__FILE__, __LINE__);
// 					// Ksnet::Calculate_time_step
// 					// 'dt' is set 0(1).
// 				Oprint();
// 				exit(1);
// 			}
// 		}
// 		min_of_time_forward
// 			= ((dt < min_of_time_forward) ? dt : min_of_time_forward);
// 	}
// 	dt = min_of_time_forward;
// 	min_of_time_forward = 1000000.;
// 
// 	/* ήüǥξƤ뤫 */
// 	time_t current_time_dummy;
// 	double data_to_check;
// 	for (i = 0; i < ninput; i++) {
// 		/* L[i]  0. ΤȤϥåʤ */
// 		if (L[i] != 0.) {
// 			/* ΥȥǤΥǡ */
// 			current_time_dummy = current_time + (time_t)dt;
// 			data_to_check =	rpu[i].Get_data(current_time_dummy);
// 			h = K[i] * pow((fabs(data_to_check)), P[i]) / B[i];
// 
// 			m = 1. / P[i];
// 			a = pow(B[i], m - 1) / pow(K[i],m);
// 			while ((L[i] / dt) < a * m * pow(h, m - 1.)) {
// 				dt /= 2.;
// 			}
// 			if (dt == 0.) {
// 				Eprint(__FILE__, __LINE__);
// 					// Ksnet::Calculate_time_step
// 					// 'dt' is set 0(2).
// 				Oprint();
// 				exit(1);
// 			}
// 		}
// 		min_of_time_forward
// 			= ((dt < min_of_time_forward) ? dt : min_of_time_forward);
// 	}
// 	if (min_of_time_forward < 1.) {
// 		Wprint(__FILE__, __LINE__);
// 			// Ksnet::Calculate_time_step
// 			// 'dt' becomes smaller than 1.
// 			// So, set 'dt' 1 by force.
// 		Oprint();
// 		min_of_time_forward = 1.;
// 	}
// 
// 	return (time_t)min_of_time_forward;

	return 20;
}

// Boolean Ksnet::Initial_output(void)
// {
// 	/* q0 η׻ */
// 	q0 = (output_current_time - sum_input_next) / sum_length;
// 	
// 	/* α̡ή̤η׻ */
// 	Get_input_info();
// 	storage_current_time = Storage_by_integral(q0);
// 
// 	/*  */
// 	/* m^3/s ǽ */
// 	sp.Send_data(current_time, output_current_time);
// 	
// 	/* ̤ι */
// 	double* ptr_swap;
// 	ptr_swap = input_current_time;
// 	input_current_time = input_next_time;
// 	input_next_time = ptr_swap;
// 	sum_input_current = sum_input_next;
// 	
// 	lateral_current_time = lateral_next_time;
// 
// 	return YES;
// }

Boolean Ksnet::Initial_output(void)
{
	// ׻ϻξüή̡¦ή̤üҤ
	// ƻνή̤׻ȤȤˡüή̤üҤ
	// 񤭽Ф

	/* ή */
	sum_input_next = 0.;
	for (int i = 0; i < ninput; i++)
	{
		if (rpu[i].Can_you_get_data(current_time, current_time) == NO)
		{
			return NO;
		}
		input_next_time[i] = rpu[i].Get_data(current_time);
		sum_input_next += input_next_time[i];
	}

	/* ¦ή */
	lateral_next_time = 0.;
    for (int i = 0; i < nlateral; i++)
	{
		if (rpl[i].Can_you_get_data(current_time, current_time) == NO)
		{
			return NO;
		}
		lateral_next_time += rpl[i].Get_data(current_time);
	}

	/* ή */
	output_current_time = sum_input_next + lateral_next_time;
	if (output_current_time < 0.)
	{
		Eprint(__FILE__, __LINE__);
    		// Ksnet::Set_initial_state
			// outflow must be >= 0.0
		Oprint();
		exit(1);
	}

	/* q0 η׻ */
	q0 = (output_current_time - sum_input_next) / sum_length;
	
	/* α̡ή̤η׻ */
	Get_input_info();
	storage_current_time = Storage_by_integral(q0);

	/*  */
	/* m^3/s ǽ */
	sp.Send_data(current_time, output_current_time);
	
	/* ̤ι */
	double* ptr_swap;
	ptr_swap = input_current_time;
	input_current_time = input_next_time;
	input_next_time = ptr_swap;
	sum_input_current = sum_input_next;
	
	lateral_current_time = lateral_next_time;

	return YES;
}

Boolean Ksnet::Calculate(void)
{
	int n;                                        /* ʬˡȿ */
	
	double q0_upper;                                     /* q0 ξ */
	double q0_lower;                                     /* q0 β */
	double q0_half;                  /* q0_upper  q0_lower Ȥʿ */
	double S_half;                          /* q0_half Ǥα̤κ */
	double S_lower;                        /* q0_lower Ǥα̤κ */
	
	/* ήüή */
	sum_input_next = 0.;
	int i;
	for (i = 0; i < ninput; i++) {
		input_next_time[i] =
			rpu[i].Get_data(current_time + time_step);
		sum_input_next += input_next_time[i];
	}

	/* ¦ή */
	lateral_next_time = 0.;
	for (i = 0; i < nlateral; i++) {
		lateral_next_time +=
		    rpl[i].Get_data(current_time + time_step);
// 		/* ¦ήñ̤ m^2/s ΤȤ */
// 		lateral_next_time *= sum_length;
	}

	Get_input_info();
	
	/* q0 ξ¤ */
	q0_upper = (2. * storage_current_time / time_step 
		+ sum_input_current + lateral_current_time + 
		lateral_next_time - output_current_time) / sum_length;
	
	/* q0 β¤ */
	q0_lower = ((storage_current_time - Storage_by_integral(q0_upper))
		* 2. / time_step + sum_input_current + lateral_current_time
		+ lateral_next_time - output_current_time) / sum_length;

	/* ʬˡˤ q0 η׻ */
	n = 0;
	do {
		n++;
		q0_half = (q0_upper + q0_lower) / 2.;
		
		S_half = Storage_by_integral(q0_half)
			- Storage_by_continuity(q0_half);
		S_lower = Storage_by_integral(q0_lower)
			- Storage_by_continuity(q0_lower);
		
		if ((S_half * S_lower) < 0.) {
			q0_upper = q0_half;
		}
		else if ((S_half * S_lower) > 0.) {
			q0_lower = q0_half;
		}
		else if (S_half == 0.) {
			q0_upper = q0_half;
			q0_lower = q0_half;
		}
		else if (S_lower == 0.) {
			q0_upper = q0_lower;
		}
	}
	while((n < 300) && (fabs(q0_upper - q0_lower) > 0.000001));
	if (n >= 300) {
		Eprint(__FILE__, __LINE__);
			// Ksnet::Calculate
			// Failure to converge.
		Oprint();
		return NO;
	}

	q0 = (q0_upper + q0_lower) / 2.;
	output_next_time = sum_input_next + q0 * sum_length;

	if (output_next_time < 0.) {
		output_next_time = 0.;
	}
	
	/*  */
	/* m^3/s ǽ */
	sp.Send_data(current_time + time_step, output_next_time);

	/* ̤ι */
	storage_current_time = Storage_by_continuity(q0);
	output_current_time = output_next_time;
	
	double* ptr_swap;
	ptr_swap = input_current_time;
	input_current_time = input_next_time;
	input_next_time = ptr_swap;
	sum_input_current = sum_input_next;
	
	lateral_current_time = lateral_next_time;

// 	printf("'%s %d' %ld : %lf -> %lf\n", object_name, object_number,
// 		Next_time(), sum_input_next, output_next_time);

  	printf("[%s %d] %ld : %f\n", object_name, object_number,
  		current_time + time_step, output_next_time);

	return YES;
}
